 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color pseudo
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PseudoP_h_
#define _xvisual_PseudoP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/Pseudo.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPseudoWidgetClass
{
    XtPointer extension;
} XvwPseudoWidgetClassPart;


typedef struct _XvwPseudoWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart          composite_class;
    ConstraintClassPart         constraint_class;
    XvwManagerWidgetClassPart   manager_class;
    XvwGraphicsWidgetClassPart  graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwPseudoWidgetClassPart	pseudo_class;
} XvwPseudoWidgetClassRec;


typedef struct
{
    /*  resources  */
    int     index1;
    int     index2;
    int     redval;
    int     greenval;
    int     blueval;
    int     alphaval;
    Boolean use_alpha;
    Boolean update_onadd;
    Boolean show_palette;
    XtCallbackList pseudo_callbacks;

    int	     num;
    int	     *indexes;
    xvobject palette;
    xvobject red;
    xvobject blue;
    xvobject green;
    xvobject alpha;
    Boolean  dirty;
} XvwPseudoPart;


typedef struct _XvwPseudoWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPseudoPart	pseudo;
} XvwPseudoWidgetRec;


typedef struct  _XvwPseudoWidgetClassRec  *XvwPseudoWidgetClass;
typedef struct  _XvwPseudoWidgetRec       *XvwPseudoWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPseudoWidget
 */
extern  XvwPseudoWidgetClassRec xvwPseudoWidgetClassRec;


#endif /* _xvisual_PseudoP_h_ */
/* Don't add after this point */
