 /*
  * Khoros: $Id$
  */

 /*
  * $Log$
  */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:
   >>>>
   >>>>    Written By: ghostwriter
   >>>>
   >>>>          Date: 
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _geometry_geometry_h_
#define _geometry_geometry_h_

#include <design.h>

	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include "geometry/geom.h"

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

/**
  * a somewhat artificial restriction on the length of geom
  * object names.  this is for the rmonster renderer, not geom svcs.
**/
#define KGEOM_MAX_NAME_LENGTH 64


/**
  * interpolation method flags for the 2d gridders.
**/
#define INVERSE_DISTANCE_2D 0
#define FOURIER_ANALYSIS_2D 1

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/


	/*-------------------------------------*
	|       macros
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

int lunion_boxes PROTO((vertex_3d *, vertex_3d *, vertex_3d *, vertex_3d *,
                        vertex_3d *, vertex_3d *));

	/* Ghostwriter Prototypes:  Do Not Erase This Comment */

int lgcuberille PROTO((kobject,kobject,kobject,float *,char *));

int lgtubeness PROTO((kobject, kobject, float, int, int));

int lglinecolor PROTO((kfile *infile, kobject vis_cmap_obj,
			kobject outobj, char *name));

int lgimpfacet PROTO((kfile *, char *, kobject));


int lkgridder_2d PROTO((kobject,kobject,int,float *,int, float *,int, int));

int lgapplytex PROTO((kobject,kobject,kobject,char *));

int lgoctmesh PROTO((kobject,int,kobject,kobject,char *));

void lcompute_3dgrad PROTO((vertex_3d *,int,int,float *,float *,float *,vertex_3d *,vertex_3d *,vertex_3d *,vertex_3d *,int));

int lglinexyz PROTO((kfile *,kobject, char *,int));
int lplot_xyz_color PROTO((kfile *,kobject, kobject, char *));

int lcolorizer PROTO((void));


int lgquadmesh PROTO((kobject,int,kobject,kobject,char *,int,float *));
int lcompute_quadmesh_vertex_normals PROTO((vertex_3d *,vertex_3d **, int, int));

int lgcmaplegend PROTO((kobject, kobject, char *, int, int, int, float *, float *, float *, float *));

int lget_coords PROTO((kobject, int, int, int, vertex_3d *));

int lgcolorize PROTO((kobject, kobject, kobject));

int lggencmap PROTO((int, float *, int, float *, int, float, float, kobject));


int lgspheres PROTO((kobject, kobject, kobject, int, float *, char *));

int lkslicer PROTO((kobject, int, int, int, float, int, float, int, int, 
			kobject));

int lset_common_geom_attributes PROTO((kobject));
int lcompute_bbox PROTO((vertex_3d *, int, vertex_3d *, vertex_3d *));
int lcompute_bbox_ptrs PROTO((vertex_3d **, int, vertex_3d *, vertex_3d *));
int lget_min_max_ptrs PROTO((vertex_3d **, int, vertex_3d **,vertex_3d **,vertex_3d **,vertex_3d **));

#endif /* _geometry_geometry_h_ */
/* Don't add after this point */
